import  os
import re

from corpus import Token, Document, Corpus

dig = re.compile('[0-9]')
def normalize_text(s):
    #such a clean and beautiful interface...
    if s is None:
        return s
    s = s.lower()
    s = re.sub(dig, '0', s)
    s = s.replace("``", '"')
    s = s.replace("''", '"')
    return s


def load_corpus(path, restricted_features=False):
    documents = []
    document_tokens = []
    document_labels = []
    with open(path) as f:
        for line in f:
            line = line.strip().split()
            if len(line) == 0:
                if len(document_tokens) > 0:
                    documents.append(Document(document_tokens, document_labels))
                    document_tokens = []
                    document_labels = []
            else:
                assert len(line) == 3
                text, pos, label = line
                features = [
                    ('word', normalize_text(text)),
                ]
                if not restricted_features:
                    features.append(('pos', pos))
                document_tokens.append(Token(text, features))
                document_labels.append(label)
        if len(document_tokens) > 0:
            documents.append(Document(document_tokens, document_labels))
    return Corpus(documents)

if __name__ == '__main__':
    import sys
    corpus = load_corpus(sys.argv[1])
    breakpoint()
